/* A Bison parser, made by GNU Bison 2.3.  */

/* Skeleton implementation for Bison's Yacc-like parsers in C

   Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002, 2003, 2004, 2005, 2006
   Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 51 Franklin Street, Fifth Floor,
   Boston, MA 02110-1301, USA.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "2.3"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Using locations.  */
#define YYLSP_NEEDED 0



/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     T_SERVICE = 258,
     T_PORT = 259,
     T_EXEC = 260,
     T_PROTO = 261,
     T_UDP = 262,
     T_TCP = 263,
     T_UID = 264,
     T_GID = 265,
     T_BACKLOG = 266,
     T_INSTANCES = 267,
     T_WAIT = 268,
     T_DEFAULT = 269,
     T_NICE = 270,
     T_INTERFACE = 271,
     T_FISH = 272,
     T_CHROOT = 273,
     T_SERVER = 274,
     T_DIR = 275,
     T_RPC = 276,
     T_VERSION = 277,
     T_NAME = 278,
     T_WRAP = 279,
     T_CAPS = 280,
     T_FAMILY = 281,
     T_IPV4 = 282,
     T_IPV6 = 283,
     T_INITGROUPS = 284,
     T_BANNER = 285,
     T_ECHO = 286,
     T_DISCARD = 287,
     T_FILTER = 288,
     T_CHARGEN = 289,
     T_LOOPBACK = 290,
     T_RLIMIT = 291,
     T_LIM_CPU = 292,
     T_LIM_FSIZE = 293,
     T_LIM_DATA = 294,
     T_LIM_STACK = 295,
     T_LIM_CORE = 296,
     T_LIM_RSS = 297,
     T_LIM_NPROC = 298,
     T_LIM_NOFILE = 299,
     T_LIM_MEMLOCK = 300,
     T_LIM_INFINITY = 301,
     T_SOFT = 302,
     T_HARD = 303,
     T_YES = 304,
     T_NO = 305,
     T_LOG = 306,
     T_PIPE = 307,
     T_SYSLOG = 308,
     T_PATH = 309,
     T_MODE = 310,
     T_ACCEPT = 311,
     T_DENY = 312,
     T_CLOSE = 313,
     T_EXIT = 314,
     T_NUMERIC = 315,
     T_QSTRING = 316,
     T_IPADDR = 317
   };
#endif
/* Tokens.  */
#define T_SERVICE 258
#define T_PORT 259
#define T_EXEC 260
#define T_PROTO 261
#define T_UDP 262
#define T_TCP 263
#define T_UID 264
#define T_GID 265
#define T_BACKLOG 266
#define T_INSTANCES 267
#define T_WAIT 268
#define T_DEFAULT 269
#define T_NICE 270
#define T_INTERFACE 271
#define T_FISH 272
#define T_CHROOT 273
#define T_SERVER 274
#define T_DIR 275
#define T_RPC 276
#define T_VERSION 277
#define T_NAME 278
#define T_WRAP 279
#define T_CAPS 280
#define T_FAMILY 281
#define T_IPV4 282
#define T_IPV6 283
#define T_INITGROUPS 284
#define T_BANNER 285
#define T_ECHO 286
#define T_DISCARD 287
#define T_FILTER 288
#define T_CHARGEN 289
#define T_LOOPBACK 290
#define T_RLIMIT 291
#define T_LIM_CPU 292
#define T_LIM_FSIZE 293
#define T_LIM_DATA 294
#define T_LIM_STACK 295
#define T_LIM_CORE 296
#define T_LIM_RSS 297
#define T_LIM_NPROC 298
#define T_LIM_NOFILE 299
#define T_LIM_MEMLOCK 300
#define T_LIM_INFINITY 301
#define T_SOFT 302
#define T_HARD 303
#define T_YES 304
#define T_NO 305
#define T_LOG 306
#define T_PIPE 307
#define T_SYSLOG 308
#define T_PATH 309
#define T_MODE 310
#define T_ACCEPT 311
#define T_DENY 312
#define T_CLOSE 313
#define T_EXIT 314
#define T_NUMERIC 315
#define T_QSTRING 316
#define T_IPADDR 317




/* Copy the first part of user declarations.  */
#line 1 "grammar.y"



#include <errno.h>
#include <fcntl.h>
#include <grp.h>
#include <netdb.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <pwd.h>
#include <rpc/rpc.h>
#include <rpc/pmap_clnt.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <sysexits.h>
#include <syslog.h>
#include <sys/socket.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <unistd.h>
#include <regex.h>
	
#include <config.h>
#include <installpaths.h>	
#include <port/port.h>

#if HAVE_DIRENT_H
# include <dirent.h>
# define NAMLEN(dirent) strlen((dirent)->d_name)
#else
# define dirent direct
# define NAMLEN(dirent) (dirent)->d_namlen
# if HAVE_SYS_NDIR_H
#  include <sys/ndir.h>
# endif
# if HAVE_SYS_DIR_H
#  include <sys/dir.h>
# endif
# if HAVE_NDIR_H
#  include <ndir.h>
# endif
#endif

#ifdef HAVE_NET_BPF_H
#include <net/bpf.h>
#endif
	
#include "assemble.h"
#include "bytecode.h"
#include "data.h"
#include "db.h"
#include "error.h"
#include "parse.h"
#include "rlinetd.h"
#include "signals.h"
#include "util.h"	

#define RL_PWARN(x...) 	rl_pwarn(curfile_name, curfile_line, x)
#define RL_PFATAL(x,y...) 	rl_pfatal(x, curfile_name, curfile_line, y)

struct userdata *userdata;
 
static struct service *current_service;
extern FILE *yyin;
extern char *rl_config; 
char **files = NULL;
static int curfile = -1, numfiles = 0; 
char *curfile_name = NULL;  /* name of the current file */
int curfile_line = 1; 	   	   /* line */
 
static struct service *defaults;

static struct logdata *logcur, *logdatas;

static struct numlist *numlist = NULL;
static struct stringlist *stringlist = NULL;

void yyerror(char *c);
int yylex();
static int bind_ports();
static void service_copy(struct service *to, struct service *from);
static void service_free(struct service *s); 
static struct service *service_new();
#ifndef HAVE_GETADDRINFO
static int getservport(char *str, char *proto);
#endif
static struct logdata *logdata_get(char *name);
static struct logdata *logdata_new();
static void pidtab_fixup();
static void validate_service(struct service *s);
static void add_directory(char *dir, char *match, char *ignore);
static int chargen_buffer();

void freebufs(); /* from parse.l */



/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* Enabling the token table.  */
#ifndef YYTOKEN_TABLE
# define YYTOKEN_TABLE 0
#endif

#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
typedef union YYSTYPE
#line 99 "grammar.y"
{
	long num;
	char *cp;
	struct passwd *uid;
	struct group *gid;
	struct opmetalist *opml;
	struct opmeta *opm;
	rlim_t rl;
}
/* Line 187 of yacc.c.  */
#line 328 "grammar.c"
	YYSTYPE;
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
# define YYSTYPE_IS_TRIVIAL 1
#endif



/* Copy the second part of user declarations.  */


/* Line 216 of yacc.c.  */
#line 341 "grammar.c"

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#elif (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
typedef signed char yytype_int8;
#else
typedef short int yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(msgid) dgettext ("bison-runtime", msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(msgid) msgid
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(e) ((void) (e))
#else
# define YYUSE(e) /* empty */
#endif

/* Identity function, used to suppress warnings about constant conditions.  */
#ifndef lint
# define YYID(n) (n)
#else
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static int
YYID (int i)
#else
static int
YYID (i)
    int i;
#endif
{
  return i;
}
#endif

#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#     ifndef _STDLIB_H
#      define _STDLIB_H 1
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (YYID (0))
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined _STDLIB_H \
       && ! ((defined YYMALLOC || defined malloc) \
	     && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef _STDLIB_H
#    define _STDLIB_H 1
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
	 || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss;
  YYSTYPE yyvs;
  };

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  YYSIZE_T yyi;				\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (YYID (0))
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack)					\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack, Stack, yysize);				\
	Stack = &yyptr->Stack;						\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (YYID (0))

#endif

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  15
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   305

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  68
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  35
/* YYNRULES -- Number of rules.  */
#define YYNRULES  110
/* YYNRULES -- Number of states.  */
#define YYNSTATES  208

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   317

#define YYTRANSLATE(YYX)						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,    66,    67,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,    63,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    64,     2,    65,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const yytype_uint16 yyprhs[] =
{
       0,     0,     3,     5,     8,    10,    12,    14,    16,    20,
      25,    31,    37,    39,    41,    44,    46,    50,    54,    58,
      62,    67,    73,    75,    78,    80,    83,    86,    88,    90,
      92,    95,    98,   102,   105,   109,   112,   116,   121,   125,
     129,   133,   138,   142,   146,   150,   156,   161,   165,   168,
     171,   174,   178,   181,   184,   185,   187,   189,   193,   197,
     201,   205,   209,   213,   217,   222,   226,   230,   232,   235,
     239,   243,   245,   249,   251,   255,   257,   260,   264,   268,
     270,   274,   276,   278,   282,   284,   286,   289,   293,   295,
     297,   299,   301,   303,   305,   307,   309,   311,   313,   315,
     317,   319,   321,   323,   325,   327,   329,   331,   333,   336,
     338
};

/* YYRHS -- A `-1'-separated list of the rules' RHS.  */
static const yytype_int8 yyrhs[] =
{
      69,     0,    -1,    70,    -1,    69,    70,    -1,    77,    -1,
      76,    -1,    72,    -1,    71,    -1,    20,    61,    63,    -1,
      20,    61,    61,    63,    -1,    20,    61,    61,    61,    63,
      -1,    51,    61,    64,    73,    65,    -1,    74,    -1,    75,
      -1,    74,    75,    -1,    63,    -1,    54,    61,    63,    -1,
       9,    97,    63,    -1,    10,    98,    63,    -1,    55,    60,
      63,    -1,    14,    64,    78,    65,    -1,     3,    61,    64,
      78,    65,    -1,    83,    -1,    78,    83,    -1,    81,    -1,
      78,    81,    -1,    78,    80,    -1,    80,    -1,    80,    -1,
      81,    -1,    79,    81,    -1,    79,    80,    -1,     5,    61,
      63,    -1,    29,    63,    -1,    15,   101,    63,    -1,    17,
      63,    -1,    36,    96,    94,    -1,    51,    53,    61,    63,
      -1,     9,    97,    63,    -1,    30,    61,    63,    -1,    34,
      82,    63,    -1,    51,    61,    61,    63,    -1,    10,    98,
      63,    -1,    18,    61,    63,    -1,    25,    61,    63,    -1,
      24,    61,    64,    79,    65,    -1,    24,    64,    79,    65,
      -1,    24,    61,    63,    -1,    24,    63,    -1,    58,    63,
      -1,    59,    63,    -1,    31,    61,    63,    -1,    35,    63,
      -1,    32,    63,    -1,    -1,    61,    -1,    63,    -1,     4,
      92,    63,    -1,     6,    99,    63,    -1,    11,    60,    63,
      -1,    12,    60,    63,    -1,    13,   102,    63,    -1,    16,
      90,    63,    -1,    19,    61,    63,    -1,    21,    64,    84,
      65,    -1,    26,   100,    63,    -1,    33,    61,    63,    -1,
      85,    -1,    84,    85,    -1,    23,    61,    63,    -1,    22,
      86,    63,    -1,    87,    -1,    86,    66,    87,    -1,    60,
      -1,    60,    67,    60,    -1,    89,    -1,    88,    89,    -1,
      47,    95,    63,    -1,    48,    95,    63,    -1,    91,    -1,
      90,    66,    91,    -1,    62,    -1,    93,    -1,    92,    66,
      93,    -1,    61,    -1,    60,    -1,    95,    63,    -1,    64,
      88,    65,    -1,    60,    -1,    46,    -1,    37,    -1,    38,
      -1,    39,    -1,    40,    -1,    41,    -1,    42,    -1,    43,
      -1,    44,    -1,    45,    -1,    60,    -1,    61,    -1,    60,
      -1,    61,    -1,     8,    -1,     7,    -1,    27,    -1,    28,
      -1,    60,    -1,    67,    60,    -1,    49,    -1,    50,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   138,   138,   139,   142,   143,   144,   145,   148,   150,
     152,   156,   171,   197,   198,   201,   202,   213,   225,   237,
     251,   260,   378,   382,   386,   397,   405,   413,   419,   423,
     434,   442,   452,   473,   500,   504,   508,   512,   520,   542,
     554,   574,   588,   608,   612,   627,   642,   659,   676,   695,
     699,   703,   707,   717,   727,   728,   731,   732,   739,   743,
     747,   751,   755,   762,   767,   768,   769,   784,   785,   788,
     792,   799,   800,   803,   807,   817,   818,   821,   825,   831,
     832,   835,   841,   842,   845,   849,   859,   863,   874,   876,
     880,   882,   884,   886,   888,   890,   892,   900,   908,   918,
     923,   931,   936,   944,   950,   958,   962,   973,   977,   983,
     987
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || YYTOKEN_TABLE
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "T_SERVICE", "T_PORT", "T_EXEC",
  "T_PROTO", "T_UDP", "T_TCP", "T_UID", "T_GID", "T_BACKLOG",
  "T_INSTANCES", "T_WAIT", "T_DEFAULT", "T_NICE", "T_INTERFACE", "T_FISH",
  "T_CHROOT", "T_SERVER", "T_DIR", "T_RPC", "T_VERSION", "T_NAME",
  "T_WRAP", "T_CAPS", "T_FAMILY", "T_IPV4", "T_IPV6", "T_INITGROUPS",
  "T_BANNER", "T_ECHO", "T_DISCARD", "T_FILTER", "T_CHARGEN", "T_LOOPBACK",
  "T_RLIMIT", "T_LIM_CPU", "T_LIM_FSIZE", "T_LIM_DATA", "T_LIM_STACK",
  "T_LIM_CORE", "T_LIM_RSS", "T_LIM_NPROC", "T_LIM_NOFILE",
  "T_LIM_MEMLOCK", "T_LIM_INFINITY", "T_SOFT", "T_HARD", "T_YES", "T_NO",
  "T_LOG", "T_PIPE", "T_SYSLOG", "T_PATH", "T_MODE", "T_ACCEPT", "T_DENY",
  "T_CLOSE", "T_EXIT", "T_NUMERIC", "T_QSTRING", "T_IPADDR", "';'", "'{'",
  "'}'", "','", "'-'", "$accept", "tles", "tle", "directory", "log",
  "log_element", "file_elements", "file_element", "default", "service",
  "service_elements", "opcode_block", "complex_opcode_element",
  "opcode_element", "optionalstring", "service_element", "rpcents",
  "rpcent", "numrangelist", "numrange", "limitents", "limitent",
  "ipaddrlists", "ipaddrlist", "portlists", "portlist", "limit",
  "limitvalue", "limittype", "userid", "groupid", "protocol", "family",
  "signed_numeric", "boolean", 0
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,    59,   123,   125,    44,    45
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint8 yyr1[] =
{
       0,    68,    69,    69,    70,    70,    70,    70,    71,    71,
      71,    72,    73,    74,    74,    75,    75,    75,    75,    75,
      76,    77,    78,    78,    78,    78,    78,    78,    79,    79,
      79,    79,    80,    80,    81,    81,    81,    81,    81,    81,
      81,    81,    81,    81,    81,    81,    81,    81,    81,    81,
      81,    81,    81,    81,    82,    82,    83,    83,    83,    83,
      83,    83,    83,    83,    83,    83,    83,    84,    84,    85,
      85,    86,    86,    87,    87,    88,    88,    89,    89,    90,
      90,    91,    92,    92,    93,    93,    94,    94,    95,    95,
      96,    96,    96,    96,    96,    96,    96,    96,    96,    97,
      97,    98,    98,    99,    99,   100,   100,   101,   101,   102,
     102
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     1,     2,     1,     1,     1,     1,     3,     4,
       5,     5,     1,     1,     2,     1,     3,     3,     3,     3,
       4,     5,     1,     2,     1,     2,     2,     1,     1,     1,
       2,     2,     3,     2,     3,     2,     3,     4,     3,     3,
       3,     4,     3,     3,     3,     5,     4,     3,     2,     2,
       2,     3,     2,     2,     0,     1,     1,     3,     3,     3,
       3,     3,     3,     3,     4,     3,     3,     1,     2,     3,
       3,     1,     3,     1,     3,     1,     2,     3,     3,     1,
       3,     1,     1,     3,     1,     1,     2,     3,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     2,     1,
       1
};

/* YYDEFACT[STATE-NAME] -- Default rule to reduce with in state
   STATE-NUM when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const yytype_uint8 yydefact[] =
{
       0,     0,     0,     0,     0,     0,     2,     7,     6,     5,
       4,     0,     0,     0,     0,     1,     3,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      54,     0,     0,     0,     0,     0,    56,     0,    27,    24,
      22,     0,     8,     0,     0,    85,    84,     0,    82,     0,
     104,   103,     0,    99,   100,     0,   101,   102,     0,     0,
       0,   109,   110,     0,   107,     0,     0,    81,     0,    79,
      35,     0,     0,     0,     0,    48,     0,     0,   105,   106,
       0,    33,     0,     0,    53,     0,    55,     0,    52,    90,
      91,    92,    93,    94,    95,    96,    97,    98,     0,     0,
       0,    49,    50,    20,    26,    25,    23,     0,     9,     0,
       0,     0,     0,    15,     0,    12,    13,    21,    57,     0,
      32,    58,    38,    42,    59,    60,    61,   108,    34,    62,
       0,    43,    63,     0,     0,     0,    67,    47,     0,     0,
      28,    29,    44,    65,    39,    51,    66,    40,    89,    88,
       0,    36,     0,     0,     0,    10,     0,     0,     0,     0,
      11,    14,    83,    80,    73,     0,    71,     0,    64,    68,
       0,    46,    31,    30,     0,     0,     0,    75,    86,    37,
      41,    17,    18,    16,    19,     0,    70,     0,    69,    45,
       0,     0,    87,    76,    74,    72,    77,    78
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,     5,     6,     7,     8,   124,   125,   126,     9,    10,
      47,   149,    48,    49,    97,    50,   145,   146,   175,   176,
     186,   187,    78,    79,    57,    58,   161,   162,   108,    65,
      68,    62,    90,    76,    73
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -61
static const yytype_int16 yypact[] =
{
      13,   -60,   -58,   -50,   -40,    69,   -61,   -61,   -61,   -61,
     -61,   -22,   201,    45,   -17,   -61,   -61,   201,    39,     1,
     105,    80,    90,     8,    35,   103,    -4,    17,    47,    55,
      66,    72,    33,    93,   129,    95,   102,   112,   114,   122,
     126,   134,   151,   -43,   135,   141,   -61,    19,   -61,   -61,
     -61,    48,   -61,     4,   113,   -61,   -61,   -51,   -61,   158,
     -61,   -61,   160,   -61,   -61,   161,   -61,   -61,   165,   166,
     175,   -61,   -61,   176,   -61,   180,   178,   -61,   -46,   -61,
     -61,   179,   181,   139,   106,   -61,   238,   182,   -61,   -61,
     183,   -61,   186,   187,   -61,   188,   -61,   191,   -61,   -61,
     -61,   -61,   -61,   -61,   -61,   -61,   -61,   -61,   -38,   196,
     197,   -61,   -61,   -61,   -61,   -61,   -61,   198,   -61,    80,
      90,   204,   206,   -61,   101,     4,   -61,   -61,   -61,    39,
     -61,   -61,   -61,   -61,   -61,   -61,   -61,   -61,   -61,   -61,
      17,   -61,   -61,   211,   214,   -19,   -61,   -61,   238,    56,
     -61,   -61,   -61,   -61,   -61,   -61,   -61,   -61,   -61,   -61,
     152,   -61,   213,   215,   216,   -61,   217,   218,   219,   220,
     -61,   -61,   -61,   -61,   210,    -6,   -61,   221,   -61,   -61,
     150,   -61,   -61,   -61,   -41,   -41,    28,   -61,   -61,   -61,
     -61,   -61,   -61,   -61,   -61,   225,   -61,   211,   -61,   -61,
     223,   224,   -61,   -61,   -61,   -61,   -61,   -61
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
     -61,   -61,   283,   -61,   -61,   -61,   -61,   167,   -61,   -61,
     273,   143,   -47,   -45,   -61,    51,   -61,   148,   -61,    97,
     -61,   109,   -61,   159,   -61,   169,   -61,    18,   -61,   184,
     185,   -61,   -61,   -61,   -61
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If zero, do what YYDEFACT says.
   If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -1
static const yytype_uint8 yytable[] =
{
     114,    11,   115,   143,   144,   158,    12,   114,   158,   115,
     109,    13,   128,   119,   120,   129,     1,   139,   110,   159,
     140,    14,   159,    18,    19,    20,   160,     2,    21,    22,
      23,    24,    25,     3,    26,    27,    28,    29,    30,   150,
      31,   151,    17,    32,    33,    34,   178,    53,    35,    36,
      37,    38,    39,    40,    41,    42,    74,   196,   121,   122,
     197,    19,    59,    75,     4,    21,    22,   123,    69,    15,
      43,    26,     1,    28,    29,   184,   185,    44,    45,    77,
      32,    33,    46,     2,   113,    35,    36,    37,    38,     3,
      40,    41,    42,   202,    84,    70,    85,    86,   116,    55,
      56,   150,   182,   151,   183,   116,    51,    43,    52,   117,
      80,   118,    60,    61,    44,    45,    81,    18,    19,    20,
       4,   181,    21,    22,    23,    24,    25,    82,    26,    27,
      28,    29,    30,   182,    31,   183,    83,    32,    33,    34,
      63,    64,    35,    36,    37,    38,    39,    40,    41,    42,
      66,    67,    71,    72,    87,    19,    88,    89,    91,    21,
      22,   143,   144,    92,    43,    26,   170,    28,    29,   147,
     148,    44,    45,    93,    32,    33,    46,    94,   127,    35,
      36,    37,    38,    95,    40,    41,    42,    96,    99,   100,
     101,   102,   103,   104,   105,   106,   107,    98,   111,   184,
     185,    43,   200,   201,   112,    18,    19,    20,    44,    45,
      21,    22,    23,    24,    25,   199,    26,    27,    28,    29,
      30,   130,    31,   131,   132,    32,    33,    34,   133,   134,
      35,    36,    37,    38,    39,    40,    41,    42,   135,   136,
     137,   138,   141,    19,   142,   152,   153,    21,    22,   154,
     155,   156,    43,    26,   157,    28,    29,   163,   164,    44,
      45,   165,    32,    33,    46,   168,   169,    35,    36,    37,
      38,   174,    40,    41,    42,   177,   188,   195,   189,   190,
     191,   192,   193,   194,   198,   204,   206,   207,    16,    43,
      54,   180,   171,   179,   205,   203,    44,    45,   172,   173,
       0,     0,     0,   166,     0,   167
};

static const yytype_int16 yycheck[] =
{
      47,    61,    47,    22,    23,    46,    64,    54,    46,    54,
      53,    61,    63,     9,    10,    66,     3,    63,    61,    60,
      66,    61,    60,     4,     5,     6,    64,    14,     9,    10,
      11,    12,    13,    20,    15,    16,    17,    18,    19,    86,
      21,    86,    64,    24,    25,    26,    65,    64,    29,    30,
      31,    32,    33,    34,    35,    36,    60,    63,    54,    55,
      66,     5,    61,    67,    51,     9,    10,    63,    60,     0,
      51,    15,     3,    17,    18,    47,    48,    58,    59,    62,
      24,    25,    63,    14,    65,    29,    30,    31,    32,    20,
      34,    35,    36,    65,    61,    60,    63,    64,    47,    60,
      61,   148,   149,   148,   149,    54,    61,    51,    63,    61,
      63,    63,     7,     8,    58,    59,    61,     4,     5,     6,
      51,    65,     9,    10,    11,    12,    13,    61,    15,    16,
      17,    18,    19,   180,    21,   180,    64,    24,    25,    26,
      60,    61,    29,    30,    31,    32,    33,    34,    35,    36,
      60,    61,    49,    50,    61,     5,    27,    28,    63,     9,
      10,    22,    23,    61,    51,    15,    65,    17,    18,    63,
      64,    58,    59,    61,    24,    25,    63,    63,    65,    29,
      30,    31,    32,    61,    34,    35,    36,    61,    37,    38,
      39,    40,    41,    42,    43,    44,    45,    63,    63,    47,
      48,    51,   184,   185,    63,     4,     5,     6,    58,    59,
       9,    10,    11,    12,    13,    65,    15,    16,    17,    18,
      19,    63,    21,    63,    63,    24,    25,    26,    63,    63,
      29,    30,    31,    32,    33,    34,    35,    36,    63,    63,
      60,    63,    63,     5,    63,    63,    63,     9,    10,    63,
      63,    63,    51,    15,    63,    17,    18,    61,    61,    58,
      59,    63,    24,    25,    63,    61,    60,    29,    30,    31,
      32,    60,    34,    35,    36,    61,    63,    67,    63,    63,
      63,    63,    63,    63,    63,    60,    63,    63,     5,    51,
      17,   148,   125,   145,   197,   186,    58,    59,   129,   140,
      -1,    -1,    -1,   119,    -1,   120
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const yytype_uint8 yystos[] =
{
       0,     3,    14,    20,    51,    69,    70,    71,    72,    76,
      77,    61,    64,    61,    61,     0,    70,    64,     4,     5,
       6,     9,    10,    11,    12,    13,    15,    16,    17,    18,
      19,    21,    24,    25,    26,    29,    30,    31,    32,    33,
      34,    35,    36,    51,    58,    59,    63,    78,    80,    81,
      83,    61,    63,    64,    78,    60,    61,    92,    93,    61,
       7,     8,    99,    60,    61,    97,    60,    61,    98,    60,
      60,    49,    50,   102,    60,    67,   101,    62,    90,    91,
      63,    61,    61,    64,    61,    63,    64,    61,    27,    28,
     100,    63,    61,    61,    63,    61,    61,    82,    63,    37,
      38,    39,    40,    41,    42,    43,    44,    45,    96,    53,
      61,    63,    63,    65,    80,    81,    83,    61,    63,     9,
      10,    54,    55,    63,    73,    74,    75,    65,    63,    66,
      63,    63,    63,    63,    63,    63,    63,    60,    63,    63,
      66,    63,    63,    22,    23,    84,    85,    63,    64,    79,
      80,    81,    63,    63,    63,    63,    63,    63,    46,    60,
      64,    94,    95,    61,    61,    63,    97,    98,    61,    60,
      65,    75,    93,    91,    60,    86,    87,    61,    65,    85,
      79,    65,    80,    81,    47,    48,    88,    89,    63,    63,
      63,    63,    63,    63,    63,    67,    63,    66,    63,    65,
      95,    95,    65,    89,    60,    87,    63,    63
};

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */

#define YYFAIL		goto yyerrlab

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yytoken = YYTRANSLATE (yychar);				\
      YYPOPSTACK (1);						\
      goto yybackup;						\
    }								\
  else								\
    {								\
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;							\
    }								\
while (YYID (0))


#define YYTERROR	1
#define YYERRCODE	256


/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#define YYRHSLOC(Rhs, K) ((Rhs)[K])
#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)				\
    do									\
      if (YYID (N))                                                    \
	{								\
	  (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;	\
	  (Current).first_column = YYRHSLOC (Rhs, 1).first_column;	\
	  (Current).last_line    = YYRHSLOC (Rhs, N).last_line;		\
	  (Current).last_column  = YYRHSLOC (Rhs, N).last_column;	\
	}								\
      else								\
	{								\
	  (Current).first_line   = (Current).last_line   =		\
	    YYRHSLOC (Rhs, 0).last_line;				\
	  (Current).first_column = (Current).last_column =		\
	    YYRHSLOC (Rhs, 0).last_column;				\
	}								\
    while (YYID (0))
#endif


/* YY_LOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

#ifndef YY_LOCATION_PRINT
# if YYLTYPE_IS_TRIVIAL
#  define YY_LOCATION_PRINT(File, Loc)			\
     fprintf (File, "%d.%d-%d.%d",			\
	      (Loc).first_line, (Loc).first_column,	\
	      (Loc).last_line,  (Loc).last_column)
# else
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX yylex (YYLEX_PARAM)
#else
# define YYLEX yylex ()
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (YYID (0))

# define YY_SYMBOL_PRINT(Title, Type, Value, Location)			  \
do {									  \
  if (yydebug)								  \
    {									  \
      YYFPRINTF (stderr, "%s ", Title);					  \
      yy_symbol_print (stderr,						  \
		  Type, Value); \
      YYFPRINTF (stderr, "\n");						  \
    }									  \
} while (YYID (0))


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_value_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# else
  YYUSE (yyoutput);
# endif
  switch (yytype)
    {
      default:
	break;
    }
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  if (yytype < YYNTOKENS)
    YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_stack_print (yytype_int16 *bottom, yytype_int16 *top)
#else
static void
yy_stack_print (bottom, top)
    yytype_int16 *bottom;
    yytype_int16 *top;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (; bottom <= top; ++bottom)
    YYFPRINTF (stderr, " %d", *bottom);
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (YYID (0))


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_reduce_print (YYSTYPE *yyvsp, int yyrule)
#else
static void
yy_reduce_print (yyvsp, yyrule)
    YYSTYPE *yyvsp;
    int yyrule;
#endif
{
  int yynrhs = yyr2[yyrule];
  int yyi;
  unsigned long int yylno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
	     yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      fprintf (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr, yyrhs[yyprhs[yyrule] + yyi],
		       &(yyvsp[(yyi + 1) - (yynrhs)])
		       		       );
      fprintf (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (yyvsp, Rule); \
} while (YYID (0))

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif



#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static YYSIZE_T
yystrlen (const char *yystr)
#else
static YYSIZE_T
yystrlen (yystr)
    const char *yystr;
#endif
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static char *
yystpcpy (char *yydest, const char *yysrc)
#else
static char *
yystpcpy (yydest, yysrc)
    char *yydest;
    const char *yysrc;
#endif
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
	switch (*++yyp)
	  {
	  case '\'':
	  case ',':
	    goto do_not_strip_quotes;

	  case '\\':
	    if (*++yyp != '\\')
	      goto do_not_strip_quotes;
	    /* Fall through.  */
	  default:
	    if (yyres)
	      yyres[yyn] = *yyp;
	    yyn++;
	    break;

	  case '"':
	    if (yyres)
	      yyres[yyn] = '\0';
	    return yyn;
	  }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into YYRESULT an error message about the unexpected token
   YYCHAR while in state YYSTATE.  Return the number of bytes copied,
   including the terminating null byte.  If YYRESULT is null, do not
   copy anything; just return the number of bytes that would be
   copied.  As a special case, return 0 if an ordinary "syntax error"
   message will do.  Return YYSIZE_MAXIMUM if overflow occurs during
   size calculation.  */
static YYSIZE_T
yysyntax_error (char *yyresult, int yystate, int yychar)
{
  int yyn = yypact[yystate];

  if (! (YYPACT_NINF < yyn && yyn <= YYLAST))
    return 0;
  else
    {
      int yytype = YYTRANSLATE (yychar);
      YYSIZE_T yysize0 = yytnamerr (0, yytname[yytype]);
      YYSIZE_T yysize = yysize0;
      YYSIZE_T yysize1;
      int yysize_overflow = 0;
      enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
      char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
      int yyx;

# if 0
      /* This is so xgettext sees the translatable formats that are
	 constructed on the fly.  */
      YY_("syntax error, unexpected %s");
      YY_("syntax error, unexpected %s, expecting %s");
      YY_("syntax error, unexpected %s, expecting %s or %s");
      YY_("syntax error, unexpected %s, expecting %s or %s or %s");
      YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s");
# endif
      char *yyfmt;
      char const *yyf;
      static char const yyunexpected[] = "syntax error, unexpected %s";
      static char const yyexpecting[] = ", expecting %s";
      static char const yyor[] = " or %s";
      char yyformat[sizeof yyunexpected
		    + sizeof yyexpecting - 1
		    + ((YYERROR_VERBOSE_ARGS_MAXIMUM - 2)
		       * (sizeof yyor - 1))];
      char const *yyprefix = yyexpecting;

      /* Start YYX at -YYN if negative to avoid negative indexes in
	 YYCHECK.  */
      int yyxbegin = yyn < 0 ? -yyn : 0;

      /* Stay within bounds of both yycheck and yytname.  */
      int yychecklim = YYLAST - yyn + 1;
      int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
      int yycount = 1;

      yyarg[0] = yytname[yytype];
      yyfmt = yystpcpy (yyformat, yyunexpected);

      for (yyx = yyxbegin; yyx < yyxend; ++yyx)
	if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
	  {
	    if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
	      {
		yycount = 1;
		yysize = yysize0;
		yyformat[sizeof yyunexpected - 1] = '\0';
		break;
	      }
	    yyarg[yycount++] = yytname[yyx];
	    yysize1 = yysize + yytnamerr (0, yytname[yyx]);
	    yysize_overflow |= (yysize1 < yysize);
	    yysize = yysize1;
	    yyfmt = yystpcpy (yyfmt, yyprefix);
	    yyprefix = yyor;
	  }

      yyf = YY_(yyformat);
      yysize1 = yysize + yystrlen (yyf);
      yysize_overflow |= (yysize1 < yysize);
      yysize = yysize1;

      if (yysize_overflow)
	return YYSIZE_MAXIMUM;

      if (yyresult)
	{
	  /* Avoid sprintf, as that infringes on the user's name space.
	     Don't have undefined behavior even if the translation
	     produced a string with the wrong number of "%s"s.  */
	  char *yyp = yyresult;
	  int yyi = 0;
	  while ((*yyp = *yyf) != '\0')
	    {
	      if (*yyp == '%' && yyf[1] == 's' && yyi < yycount)
		{
		  yyp += yytnamerr (yyp, yyarg[yyi++]);
		  yyf += 2;
		}
	      else
		{
		  yyp++;
		  yyf++;
		}
	    }
	}
      return yysize;
    }
}
#endif /* YYERROR_VERBOSE */


/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
#else
static void
yydestruct (yymsg, yytype, yyvaluep)
    const char *yymsg;
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  YYUSE (yyvaluep);

  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  switch (yytype)
    {

      default:
	break;
    }
}


/* Prevent warnings from -Wmissing-prototypes.  */

#ifdef YYPARSE_PARAM
#if defined __STDC__ || defined __cplusplus
int yyparse (void *YYPARSE_PARAM);
#else
int yyparse ();
#endif
#else /* ! YYPARSE_PARAM */
#if defined __STDC__ || defined __cplusplus
int yyparse (void);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */



/* The look-ahead symbol.  */
int yychar;

/* The semantic value of the look-ahead symbol.  */
YYSTYPE yylval;

/* Number of syntax errors so far.  */
int yynerrs;



/*----------.
| yyparse.  |
`----------*/

#ifdef YYPARSE_PARAM
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void *YYPARSE_PARAM)
#else
int
yyparse (YYPARSE_PARAM)
    void *YYPARSE_PARAM;
#endif
#else /* ! YYPARSE_PARAM */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void)
#else
int
yyparse ()

#endif
#endif
{
  
  int yystate;
  int yyn;
  int yyresult;
  /* Number of tokens to shift before error messages enabled.  */
  int yyerrstatus;
  /* Look-ahead token as an internal (translated) token number.  */
  int yytoken = 0;
#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

  /* Three stacks and their tools:
     `yyss': related to states,
     `yyvs': related to semantic values,
     `yyls': related to locations.

     Refer to the stacks thru separate pointers, to allow yyoverflow
     to reallocate them elsewhere.  */

  /* The state stack.  */
  yytype_int16 yyssa[YYINITDEPTH];
  yytype_int16 *yyss = yyssa;
  yytype_int16 *yyssp;

  /* The semantic value stack.  */
  YYSTYPE yyvsa[YYINITDEPTH];
  YYSTYPE *yyvs = yyvsa;
  YYSTYPE *yyvsp;



#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  YYSIZE_T yystacksize = YYINITDEPTH;

  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;


  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss;
  yyvsp = yyvs;

  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack.  Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	yytype_int16 *yyss1 = yyss;


	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow (YY_("memory exhausted"),
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),

		    &yystacksize);

	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	yytype_int16 *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyexhaustedlab;
	YYSTACK_RELOCATE (yyss);
	YYSTACK_RELOCATE (yyvs);

#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;


      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     look-ahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to look-ahead token.  */
  yyn = yypact[yystate];
  if (yyn == YYPACT_NINF)
    goto yydefault;

  /* Not known => get a look-ahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid look-ahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yyn == 0 || yyn == YYTABLE_NINF)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the look-ahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  yystate = yyn;
  *++yyvsp = yylval;

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 8:
#line 149 "grammar.y"
    {	add_directory((yyvsp[(2) - (3)].cp), NULL, NULL);	}
    break;

  case 9:
#line 151 "grammar.y"
    {	add_directory((yyvsp[(2) - (4)].cp), (yyvsp[(3) - (4)].cp), NULL);	}
    break;

  case 10:
#line 153 "grammar.y"
    {	add_directory((yyvsp[(2) - (5)].cp), (yyvsp[(3) - (5)].cp), (yyvsp[(4) - (5)].cp));	}
    break;

  case 11:
#line 157 "grammar.y"
    {
		if(logdata_get((yyvsp[(2) - (5)].cp))) {
			RL_PWARN("duplicate declaration of log %s, ignoring", (yyvsp[(2) - (5)].cp));
			free((yyvsp[(2) - (5)].cp));
		} else {
			logcur->name = (yyvsp[(2) - (5)].cp);
			logcur->next = logdatas;
			logdatas = logcur;
			logcur = logdata_new();
		}
		clearuserdata(&userdata);
	}
    break;

  case 12:
#line 172 "grammar.y"
    {
		if(!logcur->path) {
			RL_PWARN("No path defined for log %s", logcur->name);
		} else {
			if((logcur->index = open(logcur->path, O_CREAT|O_APPEND|O_WRONLY, logcur->mode)) < 0) {
				RL_PWARN("open(\"%s\", O_CREAT|O_APPEND|O_WRONLY, 0%o) failed (%s)",
								logcur->path, logcur->mode, strerror(errno));
			} else {

				if(fchmod(logcur->index, logcur->mode)) {
					RL_PWARN("fchmod(\"%s\", 0%o) failed (%s)",
									logcur->path, logcur->mode, 
									strerror(errno));
				}

				if(fchown(logcur->index, logcur->uid, logcur->gid)) {
					RL_PWARN("fchown(\"%s\", %d, %d) failed for log %s (%s)",
									logcur->path, logcur->uid, logcur->gid, logcur->name,
									strerror(errno));
				}
			}
		}
	}
    break;

  case 16:
#line 203 "grammar.y"
    {
		if(logcur->path) {
			RL_PWARN("duplicate path declaration (%s) "
				"in log directive %s, ignoring", (yyvsp[(2) - (3)].cp), 
				logcur->name);
			free((yyvsp[(2) - (3)].cp));
		} else {
			logcur->path = (yyvsp[(2) - (3)].cp);
		}
	}
    break;

  case 17:
#line 214 "grammar.y"
    {
		if (logcur->uid > -1) { /* FIXME */
			RL_PWARN("duplicate user declaration "
				"in log directive %s, ignoring", logcur->name);
		}
		else if ((yyvsp[(2) - (3)].uid)) {
			logcur->uid = (yyvsp[(2) - (3)].uid)->pw_uid;
		} else {
			RL_PWARN("unknown username");
		}
	}
    break;

  case 18:
#line 226 "grammar.y"
    {
		if (logcur->gid > -1) { /* FIXME */
			RL_PWARN("duplicate group declaration "
				"in log directive %s, ignoring", logcur->name);
		}
		else if ((yyvsp[(2) - (3)].gid)) {
			logcur->gid = (yyvsp[(2) - (3)].gid)->gr_gid;
		} else {
			RL_PWARN("unknown groupname");
		}
	}
    break;

  case 19:
#line 238 "grammar.y"
    {
		if (logcur->mode > -1) { /* FIXME */
			RL_PWARN("duplicate mode declaration "
				"in log directive, ignoring");
		} else if ((yyvsp[(2) - (3)].num) > 07777)  {
			RL_PWARN("invalid mode declaration "
				"in log directive, ignoring");
		} else {
			logcur->mode = (yyvsp[(2) - (3)].num);
		}
	}
    break;

  case 20:
#line 252 "grammar.y"
    {
		service_free(defaults);
 		service_copy(defaults, current_service);
		opmetalist_free((yyvsp[(3) - (4)].opml));
		free((yyvsp[(3) - (4)].opml));
	}
    break;

  case 21:
#line 261 "grammar.y"
    {
		struct opmetalist *parent;
		struct opmetalist *onexit;
		struct oplist *ops;
		int i, bound;
		int fds;
		fd_set *fdst;

		parent = opmetalist_new();
		onexit = opmetalist_new();

		current_service->name = (yyvsp[(2) - (5)].cp);
		current_service->iname = stringtab_add((yyvsp[(2) - (5)].cp));

		do { /* avoid goto */	
			
			if (current_service->disabled)
				break;
			
	 		if(current_service->socktype == SOCK_STREAM && !current_service->wait) {
	 			if(opmetalist_add((yyvsp[(4) - (5)].opml), opmeta_make(2, OP_ACCEPT, 200))) { /* !200 */
					RL_PWARN("opcode resolving problem");
					current_service->disabled++;
					break;
				}
				opmetalist_add(parent, opmeta_make(1, OP_CLOSE));

				if (current_service->internal) 
					opmetalist_add(onexit, opmeta_make(1, OP_CLOSE));
				else
					opmetalist_add(onexit, opmeta_make(1, OP_RET));

			} else {
				opmetalist_add(parent, opmeta_make(1, OP_RET));
				opmetalist_add(onexit, opmeta_make(1, OP_RET));
			}
			validate_service(current_service);

			if (current_service->disabled)
				break;

			fds = bind_ports();
			
			if(current_service->limit) {
				struct opmetalist *o;
				struct oplist *l;
				int match, under;
	
				o = opmetalist_new();
				opmetalist_add(o, opmeta_make(2, OP_LCLR, fds));
				opmetalist_add(o, opmeta_make(1, OP_RET));
				l = opmetalist_resolve(o);
				match = oplisttab_add(l);
				opmetalist_free(o);
				free(o);
				oplist_free(l);
				free(l);
				
				o = opmetalist_new();
				opmetalist_add(o, opmeta_make(2, OP_LSET, fds));
				opmetalist_add(o, opmeta_make(1, OP_RET));
				l = opmetalist_resolve(o);
				under = oplisttab_add(l);
				opmetalist_free(o);
				free(o);
				oplist_free(l);
				free(l);
				
				i = semaphore_add(current_service->limit, match, under);
				opmetalist_add((yyvsp[(4) - (5)].opml), opmeta_make(2, OP_DOWN, i));
				opmetalist_add(onexit, opmeta_make(2, OP_UP, i));
			}
			ops = opmetalist_resolve(onexit);
			current_service->onexit = oplisttab_add(ops);
			opmetalist_free(onexit);
			free(onexit);
			oplist_free(ops);
			free(ops);
			
			ops = opmetalist_resolve(parent);
			current_service->parent = oplisttab_add(ops);
			opmetalist_free(parent);
			free(parent);
			oplist_free(ops);
			free(ops);
	
			opmetalist_add((yyvsp[(4) - (5)].opml), opmeta_make(2, OP_JUMP, current_service->onexit));
			ops = opmetalist_resolve((yyvsp[(4) - (5)].opml));
			current_service->run = oplisttab_add(ops);
			opmetalist_free((yyvsp[(4) - (5)].opml));
			free((yyvsp[(4) - (5)].opml));
			oplist_free(ops);
			free(ops);
	
			fdst = fdsettab_get(fds);
			bound = getdtablesize();
			for(i = 0; i < bound; i++)
				if(FD_ISSET(i, fdst))
					read_hook(i, oplisttab_get(current_service->run), NULL);

		} while (0);	

		if (current_service->disabled) {
        	rl_warn("service %s DISABLED", current_service->name);
		} else {
			rl_note("service %s enabled", current_service->name);
			if (rl_debug > 1)
				rl_note("+-> uid=%d, sgid=%d, supgid=%d", current_service->setuid,
					current_service->setgid, current_service->supgid);
			
		}

		service_free(current_service);
		service_copy(current_service, defaults);
	}
    break;

  case 22:
#line 379 "grammar.y"
    {
		(yyval.opml) = opmetalist_new();
	}
    break;

  case 23:
#line 383 "grammar.y"
    {
		(yyval.opml) = (yyvsp[(1) - (2)].opml);
	}
    break;

  case 24:
#line 387 "grammar.y"
    {
		struct opmetalist *l;

		l = opmetalist_new();
		if(opmetalist_add(l, (yyvsp[(1) - (1)].opm))) {
			RL_PWARN("opcode resolving problem");
			current_service->disabled++;
		}
		(yyval.opml) = l;
	}
    break;

  case 25:
#line 398 "grammar.y"
    {
		if(opmetalist_add((yyvsp[(1) - (2)].opml), (yyvsp[(2) - (2)].opm))) {
			RL_PWARN("opcode resolving problem");
			current_service->disabled++;
		}
		(yyval.opml) = (yyvsp[(1) - (2)].opml);
	}
    break;

  case 26:
#line 406 "grammar.y"
    {
		(yyval.opml) = opmetalist_join((yyvsp[(1) - (2)].opml), (yyvsp[(2) - (2)].opml));
		if(!(yyval.opml)) {
			RL_PWARN("opcode resolving problem");
			current_service->disabled++;
		}
	}
    break;

  case 27:
#line 414 "grammar.y"
    {
		(yyval.opml) = (yyvsp[(1) - (1)].opml);
	}
    break;

  case 28:
#line 420 "grammar.y"
    {
		(yyval.opml) = (yyvsp[(1) - (1)].opml);
	}
    break;

  case 29:
#line 424 "grammar.y"
    {
		struct opmetalist *l;

		l = opmetalist_new();
		if(opmetalist_add(l, (yyvsp[(1) - (1)].opm))) {
			RL_PWARN("opcode resolving problem");
			current_service->disabled++;
		}
		(yyval.opml) = l;
	}
    break;

  case 30:
#line 435 "grammar.y"
    {
		if(opmetalist_add((yyvsp[(1) - (2)].opml), (yyvsp[(2) - (2)].opm))) {
			RL_PWARN("opcode resolving problem");
			current_service->disabled++;
		}
		(yyval.opml) = (yyvsp[(1) - (2)].opml);
	}
    break;

  case 31:
#line 443 "grammar.y"
    {
		(yyval.opml) = opmetalist_join((yyvsp[(1) - (2)].opml), (yyvsp[(2) - (2)].opml));
		if(!(yyval.opml)) {
			RL_PWARN("opcode resolving problem");
			current_service->disabled++;
		}
	}
    break;

  case 32:
#line 453 "grammar.y"
    {
		struct opmetalist *l;
		struct opmeta *o;
		
		l = opmetalist_new();
		o = opmeta_make(3, OP_EXEC, 666, argvtab_add((yyvsp[(2) - (3)].cp), 1));
		opmeta_fixup(o, 1, &current_service->exec);
		if(opmetalist_add(l, o)) {
			RL_PWARN("opcode resolving problem");
			current_service->disabled++;
		}
		o = opmeta_make(3, OP_FORK, 666, 666);
		opmeta_fixup(o, 1, &current_service->parent);
		opmeta_fixup(o, 2, &current_service->onexit);
		if(opmetalist_add(l, o)) {
			RL_PWARN("opcode resolving problem");
			current_service->disabled++;
		}
		(yyval.opml) = l;
	}
    break;

  case 33:
#line 474 "grammar.y"
    {
		struct opmetalist *l;
		struct opmeta *o;

		l = opmetalist_new();
		o = opmeta_make(3, OP_INITGR, 666, 666);
		opmeta_fixup(o, 1, &current_service->iuser);
		opmeta_fixup(o, 2, &current_service->supgid);
		if(opmetalist_add(l, o)) {
			RL_PWARN("opcode resolving problem");
			current_service->disabled++;
		}
		if(!current_service->sgid) {
			o = opmeta_make(2, OP_SGID, 666);
			opmeta_fixup(o, 1, &current_service->setgid);
			current_service->sgid = 1;
			if(opmetalist_add(l, o)) {
				RL_PWARN("opcode resolving problem");
				current_service->disabled++;
			}
		}
			
		(yyval.opml) = l;
	}
    break;

  case 34:
#line 501 "grammar.y"
    {
		(yyval.opm) = opmeta_make(2, OP_NICE, (yyvsp[(2) - (3)].num));
	}
    break;

  case 35:
#line 505 "grammar.y"
    {
		(yyval.opm) = opmeta_make(1, OP_FISH);
	}
    break;

  case 36:
#line 509 "grammar.y"
    {
		(yyval.opm) = opmeta_make(3, OP_RLIMIT, (yyvsp[(2) - (3)].num), (yyvsp[(3) - (3)].num));
	}
    break;

  case 37:
#line 513 "grammar.y"
    {
		int i;

		i = logtab_add(-1, (yyvsp[(3) - (4)].cp));
		(yyval.opm) = opmeta_make(2, OP_LOG, i);
		free((yyvsp[(3) - (4)].cp));
	}
    break;

  case 38:
#line 521 "grammar.y"
    {
		if((yyvsp[(2) - (3)].uid)) {
			struct opmeta *o = NULL;

			current_service->iuser = stringtab_add((yyvsp[(2) - (3)].uid)->pw_name);
			current_service->setuid = (yyvsp[(2) - (3)].uid)->pw_uid;
			if(current_service->sgid == -1) {
				current_service->setgid = (yyvsp[(2) - (3)].uid)->pw_gid;
			}
			current_service->supgid = (yyvsp[(2) - (3)].uid)->pw_gid;

			o = opmeta_make(4, OP_SGID, 666, OP_SUID, 666);
			opmeta_fixup(o, 1, &current_service->setgid);
			opmeta_fixup(o, 3, &current_service->setuid);
			(yyval.opm) = o;
		} else {
			RL_PWARN("unknown username");
			current_service->disabled++;
			(yyval.opm) = NULL;
		}
	}
    break;

  case 39:
#line 543 "grammar.y"
    {
		int ret;

		ret = buftab_addfile((yyvsp[(2) - (3)].cp));
		if(ret == -1)
			current_service->disabled++;
		(yyval.opm) = opmeta_make(16, OP_ZERO, OP_BUFCLONE, ret, OP_WHOOK, 0, OP_WUNHOOK,
										 OP_DUP, OP_BUFCOPY, OP_DUP, OP_BZNEG, 3, OP_ADD,
										 OP_WHOOK, -9, OP_POP, OP_BUFFREE);
		free((yyvsp[(2) - (3)].cp));
	}
    break;

  case 40:
#line 555 "grammar.y"
    {
		int i;

		if((yyvsp[(2) - (3)].cp)) {
			i = buftab_addfile((yyvsp[(2) - (3)].cp));
			if(i < 0)
				current_service->disabled++;
		} else {
			i = chargen_buffer();
		}
		(yyval.opm) = opmeta_make(25, OP_ZERO, OP_DUP, OP_BUFCLONE, i, OP_POP,
										 OP_POP, OP_ZERO, OP_WHOOK, 0, OP_WUNHOOK, OP_DUP,
										 OP_BUFCOPY, OP_DUP, OP_BZ, -11, OP_DUP, OP_BZNEG, 3,
										 OP_ADD, OP_WHOOK, -12, OP_POP, OP_BUFFREE, OP_JUMP, 666);
		opmeta_fixup((yyval.opm), 24, &current_service->onexit);
		current_service->internal = 1;
		if((yyvsp[(2) - (3)].cp))
			free((yyvsp[(2) - (3)].cp));
	}
    break;

  case 41:
#line 575 "grammar.y"
    {
		struct logdata *ld = logdata_get((yyvsp[(2) - (4)].cp));

		if(!ld) {
			RL_PWARN("unknown log %s", (yyvsp[(2) - (4)].cp));
			current_service->disabled++;
		} else {
			int i = logtab_add(ld->index, (yyvsp[(3) - (4)].cp));
			(yyval.opm) = opmeta_make(2, OP_LOG, i);
		}
		free((yyvsp[(2) - (4)].cp));
		free((yyvsp[(3) - (4)].cp));
	}
    break;

  case 42:
#line 589 "grammar.y"
    {
		if((yyvsp[(2) - (3)].gid)) {
			struct opmeta *o = NULL;

			if(!current_service->sgid) {
				o = opmeta_make(2, OP_SGID, 666);
				opmeta_fixup(o, 1, &current_service->setgid);
				current_service->sgid = 1;
			}
			if (current_service->supgid == -1)
				current_service->supgid = (yyvsp[(2) - (3)].gid)->gr_gid;
			current_service->setgid = (yyvsp[(2) - (3)].gid)->gr_gid;
			(yyval.opm) = o;
		} else {
			RL_PWARN("unknown group");
			current_service->disabled++;
			(yyval.opm) = NULL;
		}
	}
    break;

  case 43:
#line 609 "grammar.y"
    {
		(yyval.opm) = opmeta_make(2, OP_CHROOT, argvtab_add((yyvsp[(2) - (3)].cp), 1));
	}
    break;

  case 44:
#line 613 "grammar.y"
    {
#ifdef HAVE_CAPABILITIES
		cap_t caps = cap_from_text((yyvsp[(2) - (3)].cp));
		if(caps) {
			(yyval.opm) = opmeta_make(2, OP_SETCAP, captab_add(caps));
		} else {
			RL_PWARN("failed to parse capability string \"%s\"\n", (yyvsp[(2) - (3)].cp));
			current_service->disabled++;
		}
		free((yyvsp[(2) - (3)].cp));
#else
		RL_PFATAL(EX_DATAERR, "ABORT - support for capabilities not compiled in");
#endif
	}
    break;

  case 45:
#line 628 "grammar.y"
    {
		int i;
		struct oplist *op;

		opmetalist_add((yyvsp[(4) - (5)].opml), opmeta_make(1, OP_RET));
		op = opmetalist_resolve((yyvsp[(4) - (5)].opml));
		i = oplisttab_add(op);
		(yyval.opm) = opmeta_make(3, OP_WRAP, stringtab_add((yyvsp[(2) - (5)].cp)), i);
		free((yyvsp[(2) - (5)].cp));
		oplist_free(op);
		free(op);
		opmetalist_free((yyvsp[(4) - (5)].opml));
		free((yyvsp[(4) - (5)].opml));
	}
    break;

  case 46:
#line 643 "grammar.y"
    {
		struct opmeta *o;
		int i;
		struct oplist *op;

		opmetalist_add((yyvsp[(3) - (4)].opml), opmeta_make(1, OP_RET));
		op = opmetalist_resolve((yyvsp[(3) - (4)].opml));
		i = oplisttab_add(op);
		o = opmeta_make(3, OP_WRAP, 666, i);
		opmeta_fixup(o, 1, &current_service->iname);
		(yyval.opm) = o;
		oplist_free(op);
		free(op);
		opmetalist_free((yyvsp[(3) - (4)].opml));
		free((yyvsp[(3) - (4)].opml));
	}
    break;

  case 47:
#line 660 "grammar.y"
    {
		struct opmetalist *l;
		int i;
		struct oplist *op;

		l = opmetalist_new();
		opmetalist_add(l, opmeta_make(1, OP_EXIT));
		op = opmetalist_resolve(l);
		i = oplisttab_add(op);
		(yyval.opm) = opmeta_make(3, OP_WRAP, stringtab_add((yyvsp[(2) - (3)].cp)), i);
		free((yyvsp[(2) - (3)].cp));
		oplist_free(op);
		free(op);
		opmetalist_free(l);
		free(l);
	}
    break;

  case 48:
#line 677 "grammar.y"
    {
		struct opmetalist *l;
		struct opmeta *o;
		int i;
		struct oplist *op;

		l = opmetalist_new();
		opmetalist_add(l, opmeta_make(1, OP_EXIT));
		op = opmetalist_resolve(l);
		i = oplisttab_add(op);
		o = opmeta_make(3, OP_WRAP, 666, i);
		opmeta_fixup(o, 1, &current_service->iname);
		(yyval.opm) = o;
		oplist_free(op);
		free(op);
		opmetalist_free(l);
		free(l);
	}
    break;

  case 49:
#line 696 "grammar.y"
    {
		(yyval.opm) = opmeta_make(1, OP_CLOSE);
	}
    break;

  case 50:
#line 700 "grammar.y"
    {
		(yyval.opm) = opmeta_make(1, OP_EXIT);
	}
    break;

  case 51:
#line 704 "grammar.y"
    {
		(yyval.opm) = opmeta_make(2, OP_ECHO, argvtab_add((yyvsp[(2) - (3)].cp), 0));
	}
    break;

  case 52:
#line 708 "grammar.y"
    {
		(yyval.opm) = opmeta_make(29, OP_ZERO, OP_BUFINIT, 11, OP_RHOOK, 0, OP_BUFREAD,
										 OP_RUNHOOK, OP_DUP, OP_BZNEG, 17, OP_ADD, OP_WHOOK, 0,
										 OP_BUFWRITE, OP_WUNHOOK, OP_DUP, OP_BZ, 6, OP_DUP,
										 OP_BZNEG, 6, OP_SUB, OP_WHOOK, -11, OP_POP, OP_RHOOK, -22,
										 OP_JUMP, 666);
		opmeta_fixup((yyval.opm), 28, &current_service->onexit);
		current_service->internal = 1;
	}
    break;

  case 53:
#line 718 "grammar.y"
    {
		(yyval.opm) = opmeta_make(13, OP_ZERO, OP_RHOOK, 0, OP_RUNHOOK, OP_BUFINIT, 1024,
										 OP_BUFREAD, OP_BZNEG, 2, OP_RHOOK, -8, OP_JUMP, 666);
		opmeta_fixup((yyval.opm), 12, &current_service->onexit);
		current_service->internal = 1;
	}
    break;

  case 54:
#line 727 "grammar.y"
    {	(yyval.cp) = NULL;	}
    break;

  case 57:
#line 733 "grammar.y"
    {
		if(current_service->port)
			stringlist_free(current_service->port);
		current_service->port = stringlist;
		stringlist = NULL;
	}
    break;

  case 58:
#line 740 "grammar.y"
    {
		current_service->socktype = (yyvsp[(2) - (3)].num);
	}
    break;

  case 59:
#line 744 "grammar.y"
    {
		current_service->backlog = (yyvsp[(2) - (3)].num);
	}
    break;

  case 60:
#line 748 "grammar.y"
    {
		current_service->limit = (yyvsp[(2) - (3)].num);
	}
    break;

  case 61:
#line 752 "grammar.y"
    {
		current_service->wait  = (yyvsp[(2) - (3)].num);
	}
    break;

  case 62:
#line 756 "grammar.y"
    {
		if(current_service->interface)
			stringlist_free(current_service->interface);
		current_service->interface = stringlist;
		stringlist = NULL;
	}
    break;

  case 63:
#line 763 "grammar.y"
    {
		current_service->exec = stringtab_add((yyvsp[(2) - (3)].cp));
		free((yyvsp[(2) - (3)].cp));
	}
    break;

  case 66:
#line 770 "grammar.y"
    {
#ifdef HAVE_NET_BPF_H
		if(current_service->filter)
			free(current_service->filter);
		if(rl_readfile((yyvsp[(2) - (3)].cp), &current_service->filter, &current_service->filterlen))
			current_service->disabled++;
		free((yyvsp[(2) - (3)].cp));
#else
		RL_PFATAL(EX_DATAERR, "ABORT - support for socket filter not compiled in");
#endif
	}
    break;

  case 69:
#line 789 "grammar.y"
    {
		current_service->rpcname = (yyvsp[(2) - (3)].cp);
	}
    break;

  case 70:
#line 793 "grammar.y"
    {
		current_service->rpcvers = numlist;
		numlist = NULL;
	}
    break;

  case 73:
#line 804 "grammar.y"
    {
		numlist_add(&numlist, (yyvsp[(1) - (1)].num));
	}
    break;

  case 74:
#line 808 "grammar.y"
    {
		int i;

		if((yyvsp[(3) - (3)].num) >= (yyvsp[(1) - (3)].num))
			for(i = (yyvsp[(1) - (3)].num); i <= (yyvsp[(3) - (3)].num); i++)
				numlist_add(&numlist, i);
	}
    break;

  case 77:
#line 822 "grammar.y"
    {
		current_service->r.rlim_cur = (yyvsp[(2) - (3)].rl);
	}
    break;

  case 78:
#line 826 "grammar.y"
    {
		current_service->r.rlim_max = (yyvsp[(2) - (3)].rl);
	}
    break;

  case 81:
#line 836 "grammar.y"
    {
		stringlist_add(&stringlist, (yyvsp[(1) - (1)].cp));
	}
    break;

  case 84:
#line 846 "grammar.y"
    {
		stringlist_add(&stringlist, (yyvsp[(1) - (1)].cp));
	}
    break;

  case 85:
#line 850 "grammar.y"
    {
		char tmp[20];

		snprintf(tmp, 19, "%ld", (yyvsp[(1) - (1)].num));
		tmp[19] = '\0';
		stringlist_add(&stringlist, strdup(tmp));
	}
    break;

  case 86:
#line 860 "grammar.y"
    {
		(yyval.num) = rlimittab_add((yyvsp[(1) - (2)].rl), (yyvsp[(1) - (2)].rl));
	}
    break;

  case 87:
#line 864 "grammar.y"
    {
		if((current_service->r.rlim_max != RLIM_INFINITY) &&
			 (current_service->r.rlim_cur > current_service->r.rlim_max)) {
			RL_PWARN("invalid resource limit");
		}
		(yyval.num) = rlimittab_add(current_service->r.rlim_cur, current_service->r.rlim_max);
		current_service->r.rlim_cur = current_service->r.rlim_max = RLIM_INFINITY;
	}
    break;

  case 88:
#line 875 "grammar.y"
    { (yyval.rl) = (rlim_t)(yyvsp[(1) - (1)].num); }
    break;

  case 89:
#line 877 "grammar.y"
    { (yyval.rl) = RLIM_INFINITY; }
    break;

  case 90:
#line 881 "grammar.y"
    { (yyval.num) = RLIMIT_CPU; }
    break;

  case 91:
#line 883 "grammar.y"
    { (yyval.num) = RLIMIT_FSIZE; }
    break;

  case 92:
#line 885 "grammar.y"
    { (yyval.num) = RLIMIT_DATA; }
    break;

  case 93:
#line 887 "grammar.y"
    { (yyval.num) = RLIMIT_STACK; }
    break;

  case 94:
#line 889 "grammar.y"
    { (yyval.num) = RLIMIT_CORE; }
    break;

  case 95:
#line 891 "grammar.y"
    { (yyval.num) = RLIMIT_RSS; }
    break;

  case 96:
#line 893 "grammar.y"
    {
#ifdef RLIMIT_NPROC
		(yyval.num) = RLIMIT_NPROC;
#else
		RL_PFATAL(EX_DATAERR, "nproc limit not available on this system");
#endif
	}
    break;

  case 97:
#line 901 "grammar.y"
    {
#ifdef RLIMIT_NOFILE
		(yyval.num) = RLIMIT_NOFILE;
#else
		RL_PFATAL(EX_DATAERR, "nofile limit not available on this system");
#endif
	}
    break;

  case 98:
#line 909 "grammar.y"
    {
#ifdef RLIMIT_MEMLOCK
		(yyval.num) = RLIMIT_MEMLOCK;
#else
		RL_PFATAL(EX_DATAERR, "memlock limit not available on this system");
#endif		
	}
    break;

  case 99:
#line 919 "grammar.y"
    {
		(yyval.uid) = getpwuid((yyvsp[(1) - (1)].num));
		endpwent();
	}
    break;

  case 100:
#line 924 "grammar.y"
    {
		(yyval.uid) = getpwnam((yyvsp[(1) - (1)].cp));
		free((yyvsp[(1) - (1)].cp));
		endpwent();
	}
    break;

  case 101:
#line 932 "grammar.y"
    {
		(yyval.gid) = getgrgid((yyvsp[(1) - (1)].num));
		endgrent();
	}
    break;

  case 102:
#line 937 "grammar.y"
    {
		(yyval.gid) = getgrnam((yyvsp[(1) - (1)].cp));
		free((yyvsp[(1) - (1)].cp));
		endgrent();
	}
    break;

  case 103:
#line 945 "grammar.y"
    {
		(yyval.num) = SOCK_STREAM;
		current_service->protoname = "tcp";
		current_service->proto = IPPROTO_TCP;
	}
    break;

  case 104:
#line 951 "grammar.y"
    {
		(yyval.num) = SOCK_DGRAM;
		current_service->protoname = "udp";
		current_service->proto = IPPROTO_UDP;
	}
    break;

  case 105:
#line 959 "grammar.y"
    {
		current_service->family = PF_INET;
	}
    break;

  case 106:
#line 963 "grammar.y"
    {
#ifdef HAVE_SOCKADDR_IN6		
		current_service->family = PF_INET6;
#else		
		RL_PWARN("you have no ipv6 support");
		current_service->family = PF_INET;
#endif
	}
    break;

  case 107:
#line 974 "grammar.y"
    {
	  (yyval.num) = (yyvsp[(1) - (1)].num);
	}
    break;

  case 108:
#line 978 "grammar.y"
    {
	  (yyval.num) = (-(yyvsp[(2) - (2)].num));
	}
    break;

  case 109:
#line 984 "grammar.y"
    {
		(yyval.num) = 1;
	}
    break;

  case 110:
#line 988 "grammar.y"
    {
		(yyval.num) = 0;
	}
    break;


/* Line 1267 of yacc.c.  */
#line 2773 "grammar.c"
      default: break;
    }
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;


  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
      {
	YYSIZE_T yysize = yysyntax_error (0, yystate, yychar);
	if (yymsg_alloc < yysize && yymsg_alloc < YYSTACK_ALLOC_MAXIMUM)
	  {
	    YYSIZE_T yyalloc = 2 * yysize;
	    if (! (yysize <= yyalloc && yyalloc <= YYSTACK_ALLOC_MAXIMUM))
	      yyalloc = YYSTACK_ALLOC_MAXIMUM;
	    if (yymsg != yymsgbuf)
	      YYSTACK_FREE (yymsg);
	    yymsg = (char *) YYSTACK_ALLOC (yyalloc);
	    if (yymsg)
	      yymsg_alloc = yyalloc;
	    else
	      {
		yymsg = yymsgbuf;
		yymsg_alloc = sizeof yymsgbuf;
	      }
	  }

	if (0 < yysize && yysize <= yymsg_alloc)
	  {
	    (void) yysyntax_error (yymsg, yystate, yychar);
	    yyerror (yymsg);
	  }
	else
	  {
	    yyerror (YY_("syntax error"));
	    if (yysize != 0)
	      goto yyexhaustedlab;
	  }
      }
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse look-ahead token after an
	 error, discard it.  */

      if (yychar <= YYEOF)
	{
	  /* Return failure if at end of input.  */
	  if (yychar == YYEOF)
	    YYABORT;
	}
      else
	{
	  yydestruct ("Error: discarding",
		      yytoken, &yylval);
	  yychar = YYEMPTY;
	}
    }

  /* Else will try to reuse look-ahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule which action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (yyn != YYPACT_NINF)
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;


      yydestruct ("Error: popping",
		  yystos[yystate], yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  *++yyvsp = yylval;


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#ifndef yyoverflow
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEOF && yychar != YYEMPTY)
     yydestruct ("Cleanup: discarding lookahead",
		 yytoken, &yylval);
  /* Do not reclaim the symbols of the rule which action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
		  yystos[*yyssp], yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  /* Make sure YYID is used.  */
  return YYID (yyresult);
}


#line 992 "grammar.y"


void yyerror(char *str) {
	RL_PFATAL(EX_DATAERR, "ABORT - %s", str);
}

int yywrap() {
	fclose(yyin);
	if(numfiles) {
		while(++curfile < numfiles) {
			if((yyin = fopen(files[curfile], "r"))) {
				curfile_name = files[curfile];
				curfile_line = 1;
				return 0;
			} else {
				curfile_name = NULL;
				RL_PWARN("cannot open file %s (%s)", files[curfile],
					  strerror(errno));
			}
		}
	}
	return 1;
}

static struct service *service_new() {
	struct service *p = (struct service *)malloc(sizeof(*p));

	if (!p)
		rl_fatal(EX_SOFTWARE, "ABORT - Can't allocate memory");
	memset(p, 0, sizeof(*p));
	return p;
}

void services_free() {
	if(rl_cleanups) {
		rlp_cleanup(rl_cleanups);
		rl_cleanups = NULL;
	}
}

static void validate_service(struct service *s) {
	if(!s->name) {
		RL_PWARN("service without name");
		s->disabled++;
		return;
	}
	
	if (s->wait && s->limit != 1) {
		if (s->limit != defaults->limit)
			RL_PWARN("ignoring `instances %d' directive for service %s, because `wait' was also given", 
										s->limit, s->name);
		s->limit = 1;
	}	
	
	if(s->rpcvers) {
		char *rpcname = s->name;
		struct rpcent *rep;

		if(s->rpcname)
			rpcname = s->rpcname;
		rep = getrpcbyname(rpcname);
		if(!rep) {
			RL_PWARN("can't find rpc service %s for service %s",
							rpcname, s->name);
			s->disabled++;
		} else {
			s->rpcnum = rep->r_number;
		}
		endrpcent();
	}
}
		 
static int bind_ports() {
	int fd;
	long opt = 1;
	struct stringlist *portp;
	struct stringlist *ifp;
#ifdef HAVE_GETADDRINFO
	struct addrinfo hints;
	struct addrinfo *results = NULL, *ai;
	int ret;
#else
	void *addrbuf;
	int portnum;
	char *ctmp;
#endif	
	char *port, *addr;
	char *lasterror, *errfunc = NULL;
	int succeeded;
	fd_set fds;
	int n_fds;

	int family, socktype, protocol;
	socklen_t saddrlen;
	struct sockaddr *saddr = NULL;
	
	FD_ZERO(&fds);
	n_fds = 0;
	ifp = current_service->interface;
	do {
		struct stringlist fallback = { !current_service->rpcnum ? current_service->name : "0" , NULL };

		addr = ifp ? ifp->str : NULL;
		portp = current_service->port;
		if(!portp)
			portp = &fallback;
		do {
			lasterror = NULL;
			succeeded = 0;
				
			port = portp->str;
#ifdef HAVE_GETADDRINFO
			memset(&hints, 0, sizeof(hints));
			hints.ai_flags = AI_PASSIVE;
			hints.ai_family = current_service->family;
			hints.ai_socktype = current_service->socktype;
			hints.ai_protocol = current_service->proto;
			if(results)
				freeaddrinfo(results);
			results = NULL;
			if((ret = getaddrinfo(addr, port, &hints, &results))) {
#ifdef HAVE_GAI_STRERROR
				RL_PWARN("getaddrinfo(%s, %s) failed: %s", addr, port,
								gai_strerror(ret));
#else
				RL_PWARN("getaddrinfo(%s, %s) failed: %s", addr, port,
								"for reasons unknown" );
#endif									
				continue;
			}
			ai = results;
			do {
				family = ai->ai_family;
				socktype = ai->ai_socktype;
				protocol = ai->ai_protocol;
				saddr = ai->ai_addr;
				saddrlen = ai->ai_addrlen;
#else
				portnum = strtoul(port, &ctmp, 10);
				if(*ctmp) {
					portnum = getservport(port, current_service->protoname);
					if(portnum == -1) {
						RL_PWARN("Failed to resolve %s port %s",
										current_service->proto, port);
						continue;
					}
				}
				family = current_service->family;
				socktype = current_service->socktype;
				protocol = current_service->proto;
				if(saddr) {
					free(saddr);
					saddr = NULL;
				}
				switch(family) {
					struct sockaddr_in *sin;
#ifdef HAVE_SOCKADDR_IN6
					struct sockaddr_in6 *sin6;
#endif
						
					case PF_INET:
						saddrlen = sizeof(struct sockaddr_in);
						sin = (struct sockaddr_in *)malloc(saddrlen);
						if (!sin)
							rl_fatal(EX_SOFTWARE, "ABORT - Can't allocate memory");
						addrbuf = &sin->sin_addr.s_addr;
						sin->sin_family = current_service->family;
						sin->sin_port = htons(portnum);
						sin->sin_addr.s_addr = INADDR_ANY;
						saddr = (struct sockaddr *)sin;
						break;
#ifdef HAVE_SOCKADDR_IN6
					case PF_INET6:
						saddrlen = sizeof(struct sockaddr_in6);
						sin6 = (struct sockaddr_in6 *)malloc(saddrlen);
						if (!sin6)
							rl_fatal(EX_SOFTWARE, "ABORT - Can't allocate memory");
						addrbuf = &sin6->sin_addr.s_addr;
						sin6->sin6_family = current_service->family;
						sin6->sin6_port = htons(portnum);
						sin6->sin6_addr = IN6ADDR_ANY_INIT;
						saddr = (struct sockaddr *)sin6;
						break;
#endif							
					default:
						RL_PFATAL(EX_SOFTWARE, "funky family in service");
				}
				if(addr) {
					if(
#ifdef HAVE_INET_PTON
						 inet_pton(family, addr, addrbuf)
#else						
																/* this cast is a pain */
						 (*(unsigned int *)addrbuf = inet_addr(addr)) == -1
#endif
						 ) {
						RL_PWARN("bad address %s in service %s", addr,
										current_service->name);
						free(saddr);
						saddr = NULL;
						continue;
					}
				}
#endif				
				if((fd = socket(family, socktype, protocol)) < 0) {
					lasterror = strerror(errno);
					errfunc = "socket()";
					goto out;
				}
				if(setsockopt(fd, SOL_SOCKET, SO_REUSEADDR, &opt, sizeof(opt))) {
					RL_PWARN("setsockopt(%d, SOL_SOCKET, SO_REUSEADDR, 1) failed for service %s (%s)",
									fd, current_service->name, strerror(errno));
				}
#ifdef HAVE_NET_BPF_H
				if(current_service->filter) {
					struct bpf_program bp;

					bp.bf_len = current_service->filterlen / sizeof(struct bpf_insn);
					bp.bf_insns = current_service->filter;
					if(setsockopt(fd, SOL_SOCKET, SO_ATTACH_FILTER, &bp, sizeof(bp))) {
						lasterror = strerror(errno);
						close(fd);
						errfunc = "setsockopt(..., SO_ATTACH_FILTER)";
						goto out;
					}
				}
#endif				
				if(bind(fd, saddr, saddrlen) < 0) {
					lasterror = strerror(errno);
					close(fd);
					errfunc = "bind()";
					goto out;
				}
				if(current_service->rpcnum) {
					struct numlist *vers = current_service->rpcvers;
					struct rl_cleanup *p;
					struct sockaddr saddr2;

					if (getsockname(fd, &saddr2, &saddrlen) == -1) {
						RL_PWARN("getsockname(%d) failed for service %s", fd, current_service->name);
						memcpy(&saddr2, saddr, sizeof(struct sockaddr));
					}

					do {
						if(!pmap_set(current_service->rpcnum, vers->num,
												 protocol,
												 ntohs(((struct sockaddr_in *)&saddr2)->sin_port)))
							RL_PWARN("pmap_set(%d, %d, %d, %d) failed for service %s",
											current_service->rpcnum, vers->num,
											protocol, ntohs(((struct sockaddr_in *)&saddr2)->sin_port),
											current_service->name);
					} while((vers = vers->next));
					p = (struct rl_cleanup *)malloc(sizeof(struct rl_cleanup));
					if (!p)
						rl_fatal(EX_SOFTWARE, "ABORT - Can't allocate memory");
					p->next = rl_cleanups;
					p->data =	(struct rlc_unrpc *)malloc(sizeof(struct rlc_unrpc));
					if (!p->data)
						rl_fatal(EX_SOFTWARE, "ABORT - Can't allocate memory");
					p->type = RLC_UNRPC;
					((struct rlc_unrpc *)p->data)->vers = NULL;
					numlist_copy(&(((struct rlc_unrpc *)p->data)->vers), current_service->rpcvers);
					((struct rlc_unrpc *)p->data)->prog =	current_service->rpcnum;
					/* current_service->rpcvers = NULL;*/ /* caused segfault in the next iteration
																								   of do...while(ai=ai->ai_next) loop */
					rl_cleanups = p;
				}
				FD_SET(fd, &fds);
				if(socktype == SOCK_STREAM) {
					if(listen(fd, current_service->backlog)) {
						lasterror = strerror(errno);
						close(fd);
						errfunc = "listen(fd)";
						goto out;
					}
				}
				if(fcntl(fd, F_SETFD, 1)) {
					lasterror = strerror(errno);
					errfunc = "fcntl(fd, F_SETFD, 1)";
					close(fd);
					goto out;
				}
				if(fcntl(fd, F_SETFL, O_NDELAY)) {
					lasterror = strerror(errno);
					close(fd);
					errfunc = "fcntl(fd, F_SETFL, O_NDELAY)";
					goto out;
				}
				n_fds++;
				succeeded++;
			out:
#ifdef HAVE_GETADDRINFO
				continue;
			} while((ai = ai->ai_next));
#endif
			if(!succeeded && lasterror)
				RL_PWARN("%s failed for service %s: %s",
								errfunc, current_service->name, lasterror);
		} while(portp && (portp = portp->next));
	} while(ifp && (ifp = ifp->next));
	stringlist_free(current_service->port);
	current_service->port = NULL;
	stringlist_free(current_service->interface);
	current_service->interface = NULL;
	numlist_free(current_service->rpcvers);
	current_service->rpcvers = NULL;
#ifdef HAVE_GETADDRINFO
	if(results) {
		freeaddrinfo(results);
		results = NULL;
	}
#else
	if(saddr) {
		free(saddr);
		saddr = NULL;
	}
#endif	
	if (!n_fds)
		current_service->disabled++;
	return fdsettab_add(&fds);
}

static void service_free(struct service *s) {
	if(s->name) {
		free(s->name);
		s->name = NULL;
	}
	stringlist_free(s->port);
	s->port = NULL;
	stringlist_free(s->interface);
	s->interface = NULL;
	if(s->rpcname) {
		free(s->rpcname);
		s->rpcname = NULL;
	}
	if(s->rpcvers) {
		numlist_free(s->rpcvers);
		s->rpcvers = NULL;
	}
#ifdef HAVE_CAPABILITIES
	if(s->caps) {
		cap_free(&s->caps);
		s->caps = NULL;
	}
#endif	
#ifdef HAVE_NET_BPF_H
	if(s->filter) {
		free(s->filter);
		s->filter = NULL;
		s->filterlen = 0;
	}
#endif	
}

static void service_copy(struct service *to, struct service *from) {
	memcpy(to, from, sizeof(*to));
	to->name = NULL;
	to->port = NULL;
	to->interface = NULL;
	stringlist_copy(&to->port, from->port);
	stringlist_copy(&to->interface, from->interface);
	to->rpcname = from->rpcname ? strdup(from->rpcname) : NULL;
	to->rpcvers = NULL;
	numlist_copy(&to->rpcvers, from->rpcvers);
#ifdef HAVE_LIBCAP
	to->caps = from->caps ? cap_dup(from->caps) : NULL;
#endif
#ifdef HAVE_NET_BPF_H
	if(from->filter) {
		to->filter = malloc(from->filterlen);
		if (!to->filter)
			rl_fatal(EX_SOFTWARE, "ABORT - Can't allocate memory");
		memcpy(to->filter, from->filter, from->filterlen);
	}
#endif	
}

static struct logdata *logdata_get(char *name) {
	struct logdata *ptr = logdatas;

	if(!ptr)
		return NULL;
	do {
		if(!strcmp(name, ptr->name))
			return ptr;
	} while((ptr = ptr->next));
	return NULL;
}

static void logdatas_free() {
	struct logdata *p, *q;

	p = logdatas;
	while(p) {
		q = p->next;
		if(p->name)
			free(p->name);
		if(p->path)
			free(p->path);
		free(p);
		p = q;
	}
	logdatas = NULL;
}

static struct logdata *logdata_new() {
	struct logdata *ptr = (struct logdata *)malloc(sizeof(*ptr));

	if (!ptr)
		rl_fatal(EX_SOFTWARE, "ABORT - Can't allocate memory");

	memset(ptr, 0, sizeof(*ptr));
	ptr->index = -1;
	ptr->mode =
#ifdef S_IRUSR
		S_IRUSR|S_IWUSR|S_IRGRP
#else
		0640
#endif
		;
	ptr->uid = -1;
	ptr->gid = -1;
	return ptr;
}

void parse() {
	void freebufs();
	
	numlist = NULL;
	userdata = NULL;
	newuserdata(&userdata);
	pidtab_fixup();
	all_unhook();
	logtabs_free();
	argvtabs_free();
	rlimittabs_free();
	services_free();
	stringtabs_free();
	buftabs_free();
	oplisttabs_free();
#ifdef HAVE_CAPABILITIES
	captabs_free();
#endif	
	semaphores_free();
	fdsettabs_free();
	if(strcmp(rl_config, "-") || !rl_debug) {
		if(!(yyin = fopen(rl_config, "r"))) {
			RL_PFATAL(EX_NOINPUT, "fopen(%s) failed, aborting", rl_config);
		} else {
			curfile_name = rl_config;
			curfile_line = 1;
		}
	}

	logcur = logdata_new();
	current_service = service_new();
	defaults = service_new();
#ifdef HAVE_GETADDRINFO
	defaults->family = PF_UNSPEC;
#else	
	defaults->family = PF_INET;
#endif	
	defaults->socktype = SOCK_STREAM;
	defaults->protoname = "tcp";
	defaults->proto = IPPROTO_TCP;
	defaults->backlog = 5;
	defaults->limit = 40;
	defaults->r.rlim_cur = RLIM_INFINITY;
	defaults->r.rlim_max = RLIM_INFINITY;
	defaults->exec = -1;
	defaults->wait = 0;

	defaults->iname = -1;
	defaults->parent = -1;
	defaults->iuser  = -1;
	defaults->sgid   = -1;
	defaults->supgid = -1;
	defaults->setgid = -1;
	defaults->setuid = -1;
	service_copy(current_service, defaults);
 	yyparse();
	freebufs();
	service_free(defaults);
	free(defaults);
	defaults = NULL;
	logdatas_free();
	free(logcur);
	logcur = NULL;
	service_free(current_service);
	free(current_service);
	current_service = NULL;
	for(curfile = 0; curfile < numfiles; curfile++) {
		free(files[curfile]);
		files[curfile] = NULL;
	}
	free(files);
	files = NULL;
	clearuserdata(&userdata);
	free(userdata);
}

static void pidtab_fixup() {
	struct pidtab *p;
	int i;

	for(i = 0; i < 8; i++) {
		p = pidtabs[i].next;
		while(p) {
			if(p->inst)
				inst_free(p->inst);
			p->inst = NULL;
			p = p->next;
		}
	}
}

#ifndef HAVE_GETADDRINFO
static int getservport(char *str, char *proto) {
	struct servent *foo;
	int ret = -1;

	foo = getservbyname(str, proto);
	if(foo)
		ret = ntohs(foo->s_port);
	endservent();
	return ret;
}
#endif

static void add_directory(char *dir, char *match, char *ignore) {
	DIR *d;
	struct dirent *de;
	regex_t rmatch, rignore;
	char err[128];
	int e;
	struct stat st;
	char *file;

	if(match)
		if((e = regcomp(&rmatch, match, REG_EXTENDED|REG_NOSUB))) {
			regerror(e, &rmatch, err, 127);
			RL_PWARN("regexp compile failed for directory %s: %s",
							dir, err);
		}
	if(ignore)
		if((e = regcomp(&rignore, ignore, REG_EXTENDED|REG_NOSUB))) {
			regerror(e, &rignore, err, 127);
			RL_PWARN("regexp compile failed for directory %s: %s",
							dir, err);
		}
			
	if((d = opendir(dir))) {
		while((de = readdir(d))) {
			if(match)
				if(regexec(&rmatch, de->d_name, 0, NULL, 0))
					continue;
			if(ignore)
				if(!regexec(&rignore, de->d_name, 0, NULL, 0))
					continue;
			if(de->d_name[0] != '.') {
				file = malloc(strlen(dir) + NAMLEN(de) + 2);
				if (!file)
					rl_fatal(EX_SOFTWARE, "ABORT - Can't allocate memory");
				file[0] = '\0';
				strcat(file, dir);
				strcat(file, "/");
				strcat(file, de->d_name);
				if(stat(file, &st) || S_ISDIR(st.st_mode)) {
					RL_PWARN("file %s does not exists or"
						 " is a directory", file);	
					free(file);
					continue;
				}
				files = (char **)realloc(files, ++numfiles * sizeof(char *));
				if (!files)
					rl_fatal(EX_SOFTWARE, "ABORT - Can't allocate memory");
				files[numfiles - 1] = file;
			}
		}
	} else {
		RL_PFATAL(EX_NOINPUT, "Directory %s open failed (%s)", dir, 
			strerror(errno));
	}
	closedir(d);
	free(dir);
	if(match) {
		free(match);
		regfree(&rmatch);
	}
	if(ignore) {
		free(ignore);
		regfree(&rignore);
	}
}

int chargen_buffer() {
	static int cb = -1;
	char *b = "01234567890abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ\r\n";
	
	if(cb == -1)
		cb = buftab_addbuf(b, strlen(b));
	return cb;
}

/* vim: set ts=2: */

